OGRE: Ogre::Camera Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Friends | List of all members
Ogre::Camera Class Reference
Core | Component » Scene

A viewpoint from which the scene will be rendered. More...

`#include <OgreCamera.h>`

Inheritance diagram for Ogre::Camera:
[legend]

## Classes
class | Listener
| Listener interface so you can be notified of Camera events. More...

## Public Types
typedef map< size_t, Vector4 >::type | CustomParameterMap
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...

## Public Member Functions
| Camera (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *sm)
| Standard constructor. More...
virtual | ~Camera ()
| Standard destructor. More...
void | _autoTrack (void)
| Internal method used by OGRE to update auto-tracking cameras. More...
void | _cullScenePhase01 (Camera *renderCamera, const Camera *lodCamera, Viewport *vp, uint8 firstRq, uint8 lastRq, bool reuseCullData)
| Tells the Camera to contact the SceneManager to render from it's viewpoint. More...
const Quaternion & | _getCachedDerivedOrientation (void) const
const Vector3 & | _getCachedDerivedPosition (void) const
| Same as getDerivedPosition, but doesn't check if dirty. More...
const Plane * | _getCachedFrustumPlanes (void) const
| Returns the frustum planes, doesn't check if dirty. More...
const Quaternion & | _getCachedRealOrientation (void) const
const Vector3 & | _getCachedRealPosition (void) const
const Vector3 * | _getCachedWorldSpaceCorners (void) const
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
Real | _getLodBiasInverse (void) const
| Internal method for OGRE to use for LOD calculations. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
size_t | _getNumRenderedBatches (void) const
| Internal method to retrieve the number of visible batches in the last render. More...
size_t | _getNumRenderedFaces (void) const
| Internal method to retrieve the number of visible faces in the last render. More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
void | _notifyRenderedBatches (size_t numbatches)
| Internal method to notify camera of the visible batches in the last render. More...
void | _notifyRenderedFaces (size_t numfaces)
| Internal method to notify camera of the visible faces in the last render. More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
void | _notifyViewport (Viewport *viewport)
| Notifies this camera that a viewport is using it. More...
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost. More...
void | _renderScenePhase02 (const Camera *lodCamera, uint8 firstRq, uint8 lastRq, bool includeOverlays)
void | _resetRenderedRqs (size_t numRqs)
| Called at the beginning of each frame to know which RenderQueue IDs have been rendered. More...
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly. More...
virtual void | _setNullDatablock (void)
| Sets the datablock to a null pointer. More...
void | _setRenderedRqs (size_t rqStart, size_t rqEnd)
| Tells the camera that render queues in the range [rqStart; rqEnd) were rendered. More...
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue. More...
virtual void | addListener (Listener *l)
| Add a listener to this camera. More...
void | addPoseWeight (size_t index, float w)
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
virtual void | calcViewMatrixRelative (const Vector3 &relPos, Matrix4 &matToUpdate) const
| Calculate a view matrix for this frustum, relative to a potentially dynamic point. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
virtual void | disableCustomNearClipPlane (void)
| Disables any custom near clip plane. More...
virtual void | disableReflection (void)
| Disables reflection modification previously turned on with enableReflection. More...
virtual void | enableCustomNearClipPlane (const MovablePlane *plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes. More...
virtual void | enableCustomNearClipPlane (const Plane &plane)
| Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes. More...
virtual void | enableReflection (const MovablePlane *p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified. More...
virtual void | enableReflection (const Plane &p)
| Modifies this frustum so it always renders from the reflection of itself through the plane specified. More...
virtual void | forwardIntersect (const Plane &worldPlane, vector< Vector4 >::type *intersect3d) const
| Forward projects frustum rays to find forward intersection with plane. More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
virtual Real | getAspectRatio (void) const
| Retrieves the current aspect ratio. More...
bool | getAutoAspectRatio (void) const
| Retrieves if AutoAspectRatio is currently set or not. More...
const Vector3 & | getAutoTrackOffset (void) const
| Get the auto tracking offset for this camera, if it is auto tracking. More...
SceneNode * | getAutoTrackTarget (void) const
| Get the auto tracking target for this camera, if any. More...
const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
PlaneBoundedVolume | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, bool includeFarPlane=false)
| Gets a world-space list of planes enclosing a volume based on a viewport rectangle. More...
void | getCameraToViewportBoxVolume (Real screenLeft, Real screenTop, Real screenRight, Real screenBottom, PlaneBoundedVolume *outVolume, bool includeFarPlane=false)
| Gets a world-space list of planes enclosing a volume based on a viewport rectangle. More...
Ray | getCameraToViewportRay (Real screenx, Real screeny) const
| Gets a world space ray as cast from the camera through a viewport position. More...
void | getCameraToViewportRay (Real screenx, Real screeny, Ray *outRay) const
| Gets a world space ray as cast from the camera through a viewport position. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow. More...
Frustum * | getCullingFrustum (void) const
| Returns the custom culling frustum in use. More...
uint8 | getCurrentMaterialLod (void) const
unsigned char | getCurrentMeshLod (void) const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index. More...
const CustomParameterMap & | getCustomParameters (void) const
void | getCustomWorldSpaceCorners (ArrayVector3 outCorners[(8+ARRAY_PACKED_REALS - 1)/ARRAY_PACKED_REALS], Real customFarPlane) const
HlmsDatablock * | getDatablock (void) const
Vector3 | getDerivedDirection (void) const
| Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix. More...
const Quaternion & | getDerivedOrientation (void) const
| Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix. More...
const Vector3 & | getDerivedPosition (void) const
| Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix. More...
Vector3 | getDerivedRight (void) const
| Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix. More...
Vector3 | getDerivedUp (void) const
| Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix. More...
Vector3 | getDirection (void) const
| Gets the camera's direction. More...
Real | getFarClipDistance (void) const
| Retrieves the distance from the frustum to the far clipping plane. More...
virtual Real | getFocalLength () const
| Returns focal length of frustum. More...
virtual const Radian & | getFOVy (void) const
| Retrieves the frustums Y-dimension Field Of View (FOV). More...
virtual void | getFrustumExtents (Real &outleft, Real &outright, Real &outtop, Real &outbottom, FrustrumExtentsType frustrumExtentsType=FET_PROJ_PLANE_POS) const
| Get the extents of the frustum in view space. More...
bool | getFrustumExtentsManuallySet (void) const
virtual const Vector2 & | getFrustumOffset () const
| Retrieves the frustum offsets. More...
const Plane & | getFrustumPlane (unsigned short plane) const
| Retrieves a specified plane of the frustum (world space). More...
const Plane * | getFrustumPlanes (void) const
| Retrieves the clipping planes of the frustum (world space). More...
uint32 | getHlmsCasterHash (void) const
uint32 | getHlmsHash (void) const
IdType | getId () const
| Get the unique id of this object. More...
Viewport * | getLastViewport (void) const
| Get the last viewport which was attached to this camera. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
const LightList & | getLights (void) const
| Overridden from Renderable. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
Real | getLodBias (void) const
| Returns the level-of-detail bias factor currently applied to this camera. More...
virtual const Camera * | getLodCamera () const
| Get a pointer to the camera which should be used to determine LOD settings. More...
MaterialPtr | getMaterial (void) const
| Retrieves the material this renderable object uses. More...
const String & | getMovableType (void) const
| Overridden from MovableObject. More...
const String & | getName (void) const
| Returns the name of this object. More...
Real | getNearClipDistance (void) const
| Sets the position of the near clipping plane. More...
unsigned short | getNumPoses (void) const
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires. More...
const Quaternion & | getOrientation (void) const
| Returns the camera's current orientation. More...
const Quaternion & | getOrientationForViewUpdate (void) const
| Get the derived orientation of this frustum. More...
OrientationMode | getOrientationMode () const
| Get the orientation mode of the frustum. More...
virtual Real | getOrthoWindowHeight () const
| Gets the orthographic window height, for use with orthographic rendering only. More...
virtual Real | getOrthoWindowWidth () const
| Gets the orthographic window width, for use with orthographic rendering only. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
Real | getPixelDisplayRatio () const
| Returns an estimated ratio between a pixel and the display area it represents. More...
PlaneBoundedVolume | getPlaneBoundedVolume ()
| Gets a world-space list of planes enclosing the frustum. More...
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
const Vector3 & | getPosition (void) const
| Retrieves the camera's position. More...
const Vector3 & | getPositionForViewUpdate (void) const
| Get the derived position of this frustum. More...
virtual const Matrix4 & | getProjectionMatrix (void) const
| Gets the normal projection matrix for this frustum, ie the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1]. More...
virtual const Matrix4 & | getProjectionMatrixWithRSDepth (void) const
| Gets the depth-adjusted projection matrix for the current rendersystem, but one which still conforms to right-hand rules. More...
Vector2 | getProjectionParamsAB (void) const
| Returns the terms projectionA and projectionB in .x and .y respectively, which can be used to reconstruct linear depth from a Z buffer with the following formula: linearDepth = projectionParams.y / (fDepth - projectionParams.x);. More...
virtual ProjectionType | getProjectionType (void) const
| Retrieves info on the type of projection used (orthographic or perspective). More...
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
Vector3 | getRealDirection (void) const
| Gets the real world direction vector of the camera, including any rotation inherited from a node attachment. More...
const Quaternion & | getRealOrientation (void) const
| Gets the real world orientation of the camera, including any rotation inherited from a node attachment. More...
const Vector3 & | getRealPosition (void) const
| Gets the real world position of the camera, including any translation inherited from a node attachment. More...
Vector3 | getRealRight (void) const
| Gets the real world right vector of the camera, including any rotation inherited from a node attachment. More...
Vector3 | getRealUp (void) const
| Gets the real world up vector of the camera, including any rotation inherited from a node attachment. More...
virtual const Matrix4 & | getReflectionMatrix (void) const
| Returns the reflection matrix of the frustum if appropriate. More...
virtual const Plane & | getReflectionPlane (void) const
| Returns the reflection plane of the frustum if appropriate. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
void | getRenderOperation (v1::RenderOperation &op, bool casterPass)
| Overridden from Renderable. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
uint8 | getRenderQueueSubGroup (void) const
Vector3 | getRight (void) const
| Gets the camera's right vector. More...
SceneManager * | getSceneManager (void) const
| Returns a pointer to the SceneManager this camera is rendering through. More...
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
SkeletonInstance * | getSkeletonInstance (void) const
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden from Renderable. More...
Vector3 | getUp (void) const
| Gets the camera's up vector. More...
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection. More...
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view. More...
virtual bool | getUseIdentityViewProjMatrixIsDynamic (void) const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization) More...
virtual bool | getUseIdentityWorldMatrix (void) const
| Returns whether the world matrix is an identity matrix. More...
bool | getUseMinPixelSize () const
| Returns whether to use min display size calculations. More...
virtual OGRE_DEPRECATED const Any & | getUserAny (void) const
virtual bool | getUseRenderingDistance (void) const
| Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
const Matrix4 & | getViewMatrix (bool ownFrustumOnly) const
| Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not. More...
const Matrix4 & | getViewMatrix (void) const
| Gets the view matrix for this frustum. More...
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
const VrData * | getVrData (void) const
Matrix4 | getVrProjectionMatrix (size_t eyeIdx) const
Matrix4 | getVrViewMatrix (size_t eyeIdx) const
const PlaneList & | getWindowPlanes (void) const
| Gets the window clip planes, only applicable if isWindowSet == true. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
const Vector3 * | getWorldSpaceCorners (void) const
| Gets the world space corners of the frustum. More...
void | getWorldTransforms (Matrix4 *mat) const
| Overridden from Frustum/Renderable. More...
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index. More...
bool | hasSkeletonAnimation (void) const
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
virtual bool | isCustomNearClipPlaneEnabled (void) const
| Is a custom near clip plane in use? More...
virtual bool | isCustomProjectionMatrixEnabled (void) const
| Returns whether a custom projection matrix is in use. More...
virtual bool | isCustomViewMatrixEnabled (void) const
| Returns whether a custom view matrix is in use. More...
virtual bool | isReflected (void) const
| Returns whether this frustum is being reflected. More...
bool | isRenderedRq (size_t rqId) const
| Returns true if the asked render queue has been rendered. False otherwise. More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (const AxisAlignedBox &bound, FrustumPlane *culledBy=0) const
| Tests whether the given container is visible in the Frustum. More...
bool | isVisible (const Sphere &bound, FrustumPlane *culledBy=0) const
| Tests whether the given container is visible in the Frustum. More...
bool | isVisible (const Vector3 &vert, FrustumPlane *culledBy=0) const
| Tests whether the given vertex is visible in the Frustum. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
virtual bool | isWindowSet (void) const
| Returns if a viewport window is being used. More...
void | lookAt (const Vector3 &targetPoint)
| Points the camera at a location in worldspace. More...
void | lookAt (Real x, Real y, Real z)
| Points the camera at a location in worldspace. More...
void | move (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along world axes. More...
void | moveRelative (const Vector3 &vec)
| Moves the camera's position by the vector offset provided along it's own axes (relative to orientation). More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
void | pitch (const Radian &angle)
| Pitches the camera up/down anticlockwise around it's local z axis. More...
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered. More...
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered. More...
bool | projectSphere (const Sphere &sphere, Real *left, Real *top, Real *right, Real *bottom) const
| Project a sphere onto the near plane and get the bounding rectangle. More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index. More...
virtual void | removeListener (Listener *l)
| Remove a listener to this camera. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
virtual void | resetFrustumExtents ()
| Reset the frustum extents to be automatically derived from other params. More...
virtual void | resetWindow (void)
| Cancel view window. More...
void | roll (const Radian &angle)
| Rolls the camera anticlockwise, around its local z axis. More...
void | rotate (const Quaternion &q)
| Rotate the camera around an arbitrary axis using a Quaternion. More...
void | rotate (const Vector3 &axis, const Radian &angle)
| Rotate the camera around an arbitrary axis. More...
virtual void | setAspectRatio (Real ratio)
| Sets the aspect ratio for the frustum viewport. More...
void | setAutoAspectRatio (bool autoratio)
| If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized. More...
void | setAutoTracking (bool enabled, SceneNode *const target=0, const Vector3 &offset=Vector3::ZERO)
| Enables / disables automatic tracking of a SceneNode. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
void | setCullingFrustum (Frustum *frustum)
| Tells the camera to use a separate Frustum instance to perform culling. More...
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. More...
virtual void | setCustomProjectionMatrix (bool enable, const Matrix4 &projectionMatrix=Matrix4::IDENTITY, bool alternateDepthRange=false)
| Set whether to use a custom projection matrix on this frustum. More...
virtual void | setCustomViewMatrix (bool enable, const Matrix4 &viewMatrix=Matrix4::IDENTITY)
| Set whether to use a custom view matrix on this frustum. More...
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable. More...
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e. More...
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials. More...
void | setDirection (const Vector3 &vec)
| Sets the camera's direction vector. More...
void | setDirection (Real x, Real y, Real z)
| Sets the camera's direction vector. More...
virtual void | setFarClipDistance (Real farDist)
| Sets the distance to the far clipping plane. More...
void | setFixedYawAxis (bool useFixed, const Vector3 &fixedAxis=Vector3::UNIT_Y)
| Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice. More...
virtual void | setFocalLength (Real focalLength=1.0)
| Sets frustum focal length (used in stereo rendering). More...
virtual void | setFOVy (const Radian &fovy)
| Sets the Y-dimension Field Of View (FOV) of the frustum. More...
virtual void | setFrustumExtents (Real left, Real right, Real top, Real bottom, FrustrumExtentsType frustrumExtentsType=FET_PROJ_PLANE_POS)
| Manually set the extents of the frustum. More...
virtual void | setFrustumOffset (const Vector2 &offset)
| Sets frustum offsets, used in stereo rendering. More...
virtual void | setFrustumOffset (Real horizontal=0.0, Real vertical=0.0)
| Sets frustum offsets, used in stereo rendering. More...
void | setLightCullingVisibility (bool collectLights, bool isCubemap)
| When a camera is created via SceneManager::createCamera, there are two additional parameters. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
void | setLodBias (Real factor=1.0)
| Sets the level-of-detail factor for this Camera. More...
virtual void | setLodCamera (const Camera *lodCam)
| Set a pointer to the camera which should be used to determine LOD settings. More...
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials. More...
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS @See setHlms. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
virtual void | setNearClipDistance (Real nearDist)
| Sets the position of the near clipping plane. More...
void | setOrientation (const Quaternion &q)
| Sets the camera's orientation. More...
void | setOrientationMode (OrientationMode orientationMode)
| Set the orientation mode of the frustum. More...
virtual void | setOrthoWindow (Real w, Real h)
| Sets the orthographic window settings, for use with orthographic rendering only. More...
virtual void | setOrthoWindowHeight (Real h)
| Sets the orthographic window height, for use with orthographic rendering only. More...
virtual void | setOrthoWindowWidth (Real w)
| Sets the orthographic window width, for use with orthographic rendering only. More...
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
void | setPoseWeight (size_t index, float w)
void | setPosition (const Vector3 &vec)
| Sets the camera's position. More...
void | setPosition (Real x, Real y, Real z)
| Sets the camera's position. More...
virtual void | setProjectionType (ProjectionType pt)
| Sets the type of projection to use (orthographic or perspective). More...
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through. More...
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection. More...
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view. More...
void | setUseMinPixelSize (bool enable)
| Sets whether to use min display size calculations. More...
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
virtual void | setUseRenderingDistance (bool use)
| Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image. More...
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...
void | setVrData (VrData *vrData)
| Sets VR data for calculating left & right eyes See OpenVR sample for more info. More...
virtual void | setWindow (Real left, Real top, Real right, Real bottom)
| Sets the viewing window inside of viewport. More...
virtual void | synchroniseBaseSettingsWith (const Camera *cam)
| Synchronise core camera settings with another. More...
void | yaw (const Radian &angle)
| Rotates the camera anticlockwise around it's local y axis. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
uint8 | mCustomParameter
| Only valid when using low level materials. More...
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock. More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh
static const Real | INFINITE_FAR_PLANE_ADJUST
| Small constant used to reduce far plane projection to avoid inaccuracies. More...

## Friends
_OgreExport friend std::ostream & | operator<< (std::ostream &o, const Camera &c)
| Function for outputting to a stream. More...

## Detailed Description

A viewpoint from which the scene will be rendered.

Remarks
  OGRE renders scenes from a camera viewpoint into a buffer of some sort, normally a window or a texture (a subclass of RenderTarget). OGRE cameras support both perspective projection (the default, meaning objects get smaller the further away they are) and orthographic projection (blueprint-style, no decrease in size with distance). Each camera carries with it a style of rendering, e.g. full textured, flat shaded, wireframe), field of view, rendering distances etc, allowing you to use OGRE to create complex multi-window views if required. In addition, more than one camera can point at a single render target if required, each rendering to a subset of the target, allowing split screen and picture-in-picture views.

  Cameras maintain their own aspect ratios, field of view, and frustum, and project co-ordinates into a space measured from -1 to 1 in x and y, and 0 to 1 in z. At render time, the camera will be rendering to a Viewport which will translate these parametric co-ordinates into real screen co-ordinates. Obviously it is advisable that the viewport has the same aspect ratio as the camera to avoid distortion (unless you want it!).

  Starting Ogre 2.x, a Camera must be attached to a SceneNode, using the method SceneNode::attachObject. By default the camera is attached to the root scene node on creation. When this is done the Camera will combine it's own position/orientation settings with it's parent SceneNode. This is also useful for implementing more complex Camera / object relationships i.e. having a camera attached to a world object.

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap
| inherited

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## Constructor & Destructor Documentation

## ◆ Camera()

Ogre::Camera::Camera | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | sm
| ) |  |

Standard constructor.

## ◆ ~Camera()

virtual Ogre::Camera::~Camera | ( |  | ) |
| virtual

Standard destructor.

## Member Function Documentation

## ◆ _autoTrack()

void Ogre::Camera::_autoTrack | ( | void |  | ) |

Internal method used by OGRE to update auto-tracking cameras.

## ◆ _cullScenePhase01()

void Ogre::Camera::_cullScenePhase01 | ( | Camera * | renderCamera,
|  | const Camera * | lodCamera,
|  | Viewport * | vp,
|  | uint8 | firstRq,
|  | uint8 | lastRq,
|  | bool | reuseCullData
| ) |  |

Tells the Camera to contact the SceneManager to render from it's viewpoint.

Parameters

  vp | The viewport to render to
  includeOverlays | Whether or not any overlay objects should be included
  firstRq | First RenderQueue ID to render (inclusive)
  lastRq | Last RenderQueue ID to render (exclusive)

## ◆ _getCachedDerivedOrientation()

const Quaternion& Ogre::Camera::_getCachedDerivedOrientation | ( | void |  | ) | const
| inline

## ◆ _getCachedDerivedPosition()

const Vector3& Ogre::Camera::_getCachedDerivedPosition | ( | void |  | ) | const
| inline

Same as getDerivedPosition, but doesn't check if dirty.

## ◆ _getCachedFrustumPlanes()

const Plane* Ogre::Frustum::_getCachedFrustumPlanes | ( | void |  | ) | const
| inlineinherited

Returns the frustum planes, doesn't check if dirty.

## ◆ _getCachedRealOrientation()

const Quaternion& Ogre::Camera::_getCachedRealOrientation | ( | void |  | ) | const
| inline

## ◆ _getCachedRealPosition()

const Vector3& Ogre::Camera::_getCachedRealPosition | ( | void |  | ) | const
| inline

## ◆ _getCachedWorldSpaceCorners()

const Vector3* Ogre::Frustum::_getCachedWorldSpaceCorners | ( | void |  | ) | const
| inlineinherited

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getLodBiasInverse()

Real Ogre::Camera::_getLodBiasInverse | ( | void |  | ) | const

Internal method for OGRE to use for LOD calculations.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getNumRenderedBatches()

size_t Ogre::Camera::_getNumRenderedBatches | ( | void |  | ) | const

Internal method to retrieve the number of visible batches in the last render.

## ◆ _getNumRenderedFaces()

size_t Ogre::Camera::_getNumRenderedFaces | ( | void |  | ) | const

Internal method to retrieve the number of visible faces in the last render.

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _notifyAttached()

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent | ) |
| virtualinherited

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::ParticleSystem, and Ogre::v1::Entity.

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyRenderedBatches()

void Ogre::Camera::_notifyRenderedBatches | ( | size_t | numbatches | ) |

Internal method to notify camera of the visible batches in the last render.

## ◆ _notifyRenderedFaces()

void Ogre::Camera::_notifyRenderedFaces | ( | size_t | numfaces | ) |

Internal method to notify camera of the visible faces in the last render.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _notifyViewport()

void Ogre::Camera::_notifyViewport | ( | Viewport * | viewport | ) |
| inline

Notifies this camera that a viewport is using it.

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::v1::ManualObject, and Ogre::v1::BillboardSet.

## ◆ _renderScenePhase02()

void Ogre::Camera::_renderScenePhase02 | ( | const Camera * | lodCamera,
|  | uint8 | firstRq,
|  | uint8 | lastRq,
|  | bool | includeOverlays
| ) |  |

## ◆ _resetRenderedRqs()

void Ogre::Camera::_resetRenderedRqs | ( | size_t | numRqs | ) |

Called at the beginning of each frame to know which RenderQueue IDs have been rendered.

Parameters

  numRqs | Max number of total possible render queues in this frame

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _setHlmsHashes()

virtual void Ogre::Renderable::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash
| ) |  |
| virtualinherited

Manually sets the hlms hashes. Don't call this directly.

Reimplemented in Ogre::SubItem.

## ◆ _setNullDatablock()

virtual void Ogre::Renderable::_setNullDatablock | ( | void |  | ) |
| virtualinherited

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ _setRenderedRqs()

void Ogre::Camera::_setRenderedRqs | ( | size_t | rqStart,
|  | size_t | rqEnd
| ) |  |

Tells the camera that render queues in the range [rqStart; rqEnd) were rendered.

Remarks
  This function may be called before having been actually rendered (i.e. during the culling phase 01)

Parameters

  rqStart | The first render queue in the range to be rendered. Inclusive.
  rqEnd | Next to last render queue id to be rendered. Must be below or equal than the value passed to

See also
  _resetRenderedRqs

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) |  | const
| virtualinherited

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ _updateRenderQueue()

virtual void Ogre::MovableObject::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| inlinevirtualinherited

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

Remarks
  The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Reimplemented in Ogre::v1::StaticGeometry::Region, Ogre::ParticleSystem, Ogre::v1::ManualObject, Ogre::Light, Ogre::v1::Entity, Ogre::v1::BillboardSet, Ogre::MovablePlane, and Ogre::v1::BillboardChain.

## ◆ addListener()

virtual void Ogre::Camera::addListener | ( | Listener * | l | ) |
| virtual

Add a listener to this camera.

## ◆ addPoseWeight()

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ calcViewMatrixRelative()

virtual void Ogre::Frustum::calcViewMatrixRelative | ( | const Vector3 & | relPos,
|  | Matrix4 & | matToUpdate
| ) |  | const
| virtualinherited

Calculate a view matrix for this frustum, relative to a potentially dynamic point.

Mainly for use by OGRE internally when using camera-relative rendering for frustums that are not the centre (e.g. texture projection)

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ disableCustomNearClipPlane()

virtual void Ogre::Frustum::disableCustomNearClipPlane | ( | void |  | ) |
| virtualinherited

Disables any custom near clip plane.

## ◆ disableReflection()

virtual void Ogre::Frustum::disableReflection | ( | void |  | ) |
| virtualinherited

Disables reflection modification previously turned on with enableReflection.

## ◆ enableCustomNearClipPlane() [1/2]

virtual void Ogre::Frustum::enableCustomNearClipPlane | ( | const MovablePlane * | plane | ) |
| virtualinherited

Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.

Remarks
  There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue.

  This version of the method links to a plane, rather than requiring a by-value plane definition, and therefore you can make changes to the plane (e.g. by moving / rotating the node it is attached to) and they will automatically affect this object.

Note
  This technique only works for perspective projection.

Parameters

  plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

## ◆ enableCustomNearClipPlane() [2/2]

virtual void Ogre::Frustum::enableCustomNearClipPlane | ( | const Plane & | plane | ) |
| virtualinherited

Links the frustum to a custom near clip plane, which can be used to clip geometry in a custom manner without using user clip planes.

Remarks
  There are several applications for clipping a scene arbitrarily by a single plane; the most common is when rendering a reflection to
  a texture, and you only want to render geometry that is above the water plane (to do otherwise results in artefacts). Whilst it is possible to use user clip planes, they are not supported on all cards, and sometimes are not hardware accelerated when they are available. Instead, where a single clip plane is involved, this technique uses a 'fudging' of the near clip plane, which is available and fast on all hardware, to perform as the arbitrary clip plane. This does change the shape of the frustum, leading to some depth buffer loss of precision, but for many of the uses of this technique that is not an issue.

Note
  This technique only works for perspective projection.

Parameters

  plane | The plane to link to to perform the clipping. This plane must continue to exist while the camera is linked to it; do not destroy it before the frustum.

## ◆ enableReflection() [1/2]

virtual void Ogre::Frustum::enableReflection | ( | const MovablePlane * | p | ) |
| virtualinherited

Modifies this frustum so it always renders from the reflection of itself through the plane specified.

Note that this version of the method links to a plane so that changes to it are picked up automatically. It is important that this plane continues to exist whilst this object does; do not destroy the plane before the frustum.

Remarks
  This is obviously useful for performing planar reflections.

## ◆ enableReflection() [2/2]

virtual void Ogre::Frustum::enableReflection | ( | const Plane & | p | ) |
| virtualinherited

Modifies this frustum so it always renders from the reflection of itself through the plane specified.

Remarks
  This is obviously useful for performing planar reflections.

## ◆ forwardIntersect()

virtual void Ogre::Camera::forwardIntersect | ( | const Plane & | worldPlane,
|  | vector< Vector4 >::type * | intersect3d
| ) |  | const
| virtual

Forward projects frustum rays to find forward intersection with plane.

Remarks
  Forward projection may lead to intersections at infinity.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getAspectRatio()

virtual Real Ogre::Frustum::getAspectRatio | ( | void |  | ) | const
| virtualinherited

Retrieves the current aspect ratio.

## ◆ getAutoAspectRatio()

bool Ogre::Camera::getAutoAspectRatio | ( | void |  | ) | const

Retrieves if AutoAspectRatio is currently set or not.

## ◆ getAutoTrackOffset()

const Vector3& Ogre::Camera::getAutoTrackOffset | ( | void |  | ) | const
| inline

Get the auto tracking offset for this camera, if it is auto tracking.

## ◆ getAutoTrackTarget()

SceneNode* Ogre::Camera::getAutoTrackTarget | ( | void |  | ) | const
| inline

Get the auto tracking target for this camera, if any.

## ◆ getBoundingBox()

const AxisAlignedBox& Ogre::Frustum::getBoundingBox | ( | void |  | ) | const
| inherited

Overridden from MovableObject.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCameraToViewportBoxVolume() [1/2]

PlaneBoundedVolume Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | bool | includeFarPlane = `false`
| ) |  |

Gets a world-space list of planes enclosing a volume based on a viewport rectangle.

Remarks
  Can be useful for populating a PlaneBoundedVolumeListSceneQuery, e.g. for a rubber-band selection.

Parameters

  screenLeft,screenTop,screenRight,screenBottom | The bounds of the on-screen rectangle, expressed in normalised screen coordinates [0,1]
  includeFarPlane | If true, the volume is truncated by the camera far plane, by default it is left open-ended

## ◆ getCameraToViewportBoxVolume() [2/2]

void Ogre::Camera::getCameraToViewportBoxVolume | ( | Real | screenLeft,
|  | Real | screenTop,
|  | Real | screenRight,
|  | Real | screenBottom,
|  | PlaneBoundedVolume * | outVolume,
|  | bool | includeFarPlane = `false`
| ) |  |

Gets a world-space list of planes enclosing a volume based on a viewport rectangle.

Remarks
  Can be useful for populating a PlaneBoundedVolumeListSceneQuery, e.g. for a rubber-band selection.

Parameters

  screenLeft,screenTop,screenRight,screenBottom | The bounds of the on-screen rectangle, expressed in normalised screen coordinates [0,1]
  outVolume | The plane list to populate with the result
  includeFarPlane | If true, the volume is truncated by the camera far plane, by default it is left open-ended

## ◆ getCameraToViewportRay() [1/2]

Ray Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny
| ) |  | const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]

## ◆ getCameraToViewportRay() [2/2]

void Ogre::Camera::getCameraToViewportRay | ( | Real | screenx,
|  | Real | screeny,
|  | Ray * | outRay
| ) |  | const

Gets a world space ray as cast from the camera through a viewport position.

Parameters

  screenx,screeny | The x and y position at which the ray should intersect the viewport, in normalised screen coordinates [0,1]
  outRay | Ray instance to populate with result

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const
| inlinevirtualinherited

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::ManualObject::ManualObjectSection, Ogre::WireAabb, Ogre::SubItem, Ogre::v1::SubEntity, Ogre::v1::StaticGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::VoxelVisualizer, and Ogre::IfdProbeVisualizer.

## ◆ getCullingFrustum()

Frustum* Ogre::Camera::getCullingFrustum | ( | void |  | ) | const
| inline

Returns the custom culling frustum in use.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomParameter()

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap& Ogre::Renderable::getCustomParameters | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomWorldSpaceCorners()

void Ogre::Frustum::getCustomWorldSpaceCorners | ( | ArrayVector3 | outCorners[(8+ARRAY_PACKED_REALS - 1)/ARRAY_PACKED_REALS],
|  | Real | customFarPlane
| ) |  | const
| inherited

## ◆ getDatablock()

HlmsDatablock* Ogre::Renderable::getDatablock | ( | void |  | ) | const
| inlineinherited

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getDerivedDirection()

Vector3 Ogre::Camera::getDerivedDirection | ( | void |  | ) | const

Gets the derived direction vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedOrientation()

const Quaternion& Ogre::Camera::getDerivedOrientation | ( | void |  | ) | const

Gets the derived orientation of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedPosition()

const Vector3& Ogre::Camera::getDerivedPosition | ( | void |  | ) | const

Gets the derived position of the camera, including any translation inherited from a node attachment and reflection matrix.

## ◆ getDerivedRight()

Vector3 Ogre::Camera::getDerivedRight | ( | void |  | ) | const

Gets the derived right vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDerivedUp()

Vector3 Ogre::Camera::getDerivedUp | ( | void |  | ) | const

Gets the derived up vector of the camera, including any rotation inherited from a node attachment and reflection matrix.

## ◆ getDirection()

Vector3 Ogre::Camera::getDirection | ( | void |  | ) | const

Gets the camera's direction.

## ◆ getFarClipDistance()

Real Ogre::Camera::getFarClipDistance | ( | void |  | ) | const
| virtual

Retrieves the distance from the frustum to the far clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getFocalLength()

virtual Real Ogre::Frustum::getFocalLength | ( |  | ) | const
| virtualinherited

Returns focal length of frustum.

## ◆ getFOVy()

virtual const Radian& Ogre::Frustum::getFOVy | ( | void |  | ) | const
| virtualinherited

Retrieves the frustums Y-dimension Field Of View (FOV).

## ◆ getFrustumExtents()

virtual void Ogre::Frustum::getFrustumExtents | ( | Real & | outleft,
|  | Real & | outright,
|  | Real & | outtop,
|  | Real & | outbottom,
|  | FrustrumExtentsType | frustrumExtentsType = `FET_PROJ_PLANE_POS`
| ) |  | const
| virtualinherited

Get the extents of the frustum in view space.

Parameters

  left,right,top,bottom | The position where the side clip planes intersect the near clip plane, in eye space OR the tangent of the half angles from the eye to the edges of the near clip plane
  frustrumExtentsType | Specifies in what format the extents are returned. See OgreFrustrum::setFrustumExtents for more information

## ◆ getFrustumExtentsManuallySet()

bool Ogre::Frustum::getFrustumExtentsManuallySet | ( | void |  | ) | const
| inherited

## ◆ getFrustumOffset()

virtual const Vector2& Ogre::Frustum::getFrustumOffset | ( |  | ) | const
| virtualinherited

Retrieves the frustum offsets.

## ◆ getFrustumPlane()

const Plane& Ogre::Camera::getFrustumPlane | ( | unsigned short | plane | ) | const

Retrieves a specified plane of the frustum (world space).

Remarks
  Gets a reference to one of the planes which make up the frustum frustum, e.g. for clipping purposes.

## ◆ getFrustumPlanes()

const Plane* Ogre::Frustum::getFrustumPlanes | ( | void |  | ) | const
| inherited

Retrieves the clipping planes of the frustum (world space).

Remarks
  The clipping planes are ordered as declared in enumerate constants FrustumPlane.

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( | void |  | ) | const
| inlineinherited

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getLastViewport()

Viewport* Ogre::Camera::getLastViewport | ( | void |  | ) | const
| inline

Get the last viewport which was attached to this camera.

Note
  This is not guaranteed to be the only viewport which is using this camera, just the last once which was created referring to it.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getLights()

const LightList& Ogre::Frustum::getLights | ( | void |  | ) | const
| virtualinherited

Overridden from Renderable.

Implements Ogre::Renderable.

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getLodBias()

Real Ogre::Camera::getLodBias | ( | void |  | ) | const

Returns the level-of-detail bias factor currently applied to this camera.

Remarks
  See Camera::setLodBias for more details.

## ◆ getLodCamera()

virtual const Camera* Ogre::Camera::getLodCamera | ( |  | ) | const
| virtual

Get a pointer to the camera which should be used to determine LOD settings.

Remarks
  If setLodCamera hasn't been called with a different camera, this method will return 'this'.

## ◆ getMaterial()

MaterialPtr Ogre::Renderable::getMaterial | ( | void |  | ) | const
| inherited

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS. @See getDatablock

## ◆ getMovableType()

const String& Ogre::Camera::getMovableType | ( | void |  | ) | const
| virtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNearClipDistance()

Real Ogre::Camera::getNearClipDistance | ( | void |  | ) | const
| virtual

Sets the position of the near clipping plane.

Reimplemented from Ogre::Frustum.

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( | void |  | ) | const
| inherited

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BorderRenderable.

## ◆ getOrientation()

const Quaternion& Ogre::Camera::getOrientation | ( | void |  | ) | const

Returns the camera's current orientation.

## ◆ getOrientationForViewUpdate()

const Quaternion& Ogre::Camera::getOrientationForViewUpdate | ( | void |  | ) | const
| virtual

Get the derived orientation of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ getOrientationMode()

OrientationMode Ogre::Frustum::getOrientationMode | ( |  | ) | const
| inherited

Get the orientation mode of the frustum.

Remarks
  Getting the orientation of a frustum is only supported on iOS at this time. An exception is thrown on other platforms.

## ◆ getOrthoWindowHeight()

virtual Real Ogre::Frustum::getOrthoWindowHeight | ( |  | ) | const
| virtualinherited

Gets the orthographic window height, for use with orthographic rendering only.

## ◆ getOrthoWindowWidth()

virtual Real Ogre::Frustum::getOrthoWindowWidth | ( |  | ) | const
| virtualinherited

Gets the orthographic window width, for use with orthographic rendering only.

Note
  This is calculated from the orthographic height and the aspect ratio

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getPixelDisplayRatio()

Real Ogre::Camera::getPixelDisplayRatio | ( |  | ) | const
| inline

Returns an estimated ratio between a pixel and the display area it represents.

For orthographic cameras this function returns the amount of meters covered by a single pixel along the vertical axis. For perspective cameras the value returned is the amount of meters covered by a single pixel per meter distance from the camera.

Note
  This parameter is calculated just before the camera is rendered
  This parameter is used in min display size calculations.

## ◆ getPlaneBoundedVolume()

PlaneBoundedVolume Ogre::Frustum::getPlaneBoundedVolume | ( |  | ) |
| inherited

Gets a world-space list of planes enclosing the frustum.

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inlinevirtualinherited

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

Referenced by Ogre::v1::BorderRenderable::getPolygonModeOverrideable().

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const
| inherited

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const
| inherited

## ◆ getPoseTexBuffer()

TexBufferPacked* Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const
| inherited

## ◆ getPoseWeight()

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const
| inherited

## ◆ getPoseWeights()

float* Ogre::Renderable::getPoseWeights | ( |  | ) | const
| inherited

## ◆ getPosition()

const Vector3& Ogre::Camera::getPosition | ( | void |  | ) | const

Retrieves the camera's position.

## ◆ getPositionForViewUpdate()

const Vector3& Ogre::Camera::getPositionForViewUpdate | ( | void |  | ) | const
| virtual

Get the derived position of this frustum.

Reimplemented from Ogre::Frustum.

## ◆ getProjectionMatrix()

virtual const Matrix4& Ogre::Frustum::getProjectionMatrix | ( | void |  | ) | const
| virtualinherited

Gets the normal projection matrix for this frustum, ie the projection matrix which conforms to standard right-handed rules and uses depth range [-1,+1].

Remarks
  This differs from the rendering-API dependent getProjectionMatrixRS in that it always returns a right-handed projection matrix with depth range [-1,+1], result no matter what rendering API is being used - this is required for some uniform algebra for example.

## ◆ getProjectionMatrixWithRSDepth()

virtual const Matrix4& Ogre::Frustum::getProjectionMatrixWithRSDepth | ( | void |  | ) | const
| virtualinherited

Gets the depth-adjusted projection matrix for the current rendersystem, but one which still conforms to right-hand rules.

Remarks
  This differs from the rendering-API dependent getProjectionMatrix in that it always returns a right-handed projection matrix result no matter what rendering API is being used - this is required for vertex and fragment programs for example. However, the resulting depth range may still vary between render systems since D3D uses [0,1] and GL uses [-1,1], and the range must be kept the same between programmable and fixed-function pipelines.

## ◆ getProjectionParamsAB()

Vector2 Ogre::Frustum::getProjectionParamsAB | ( | void |  | ) | const
| inherited

Returns the terms projectionA and projectionB in .x and .y respectively, which can be used to reconstruct linear depth from a Z buffer with the following formula: linearDepth = projectionParams.y / (fDepth - projectionParams.x);.

## ◆ getProjectionType()

virtual ProjectionType Ogre::Frustum::getProjectionType | ( | void |  | ) | const
| virtualinherited

Retrieves info on the type of projection used (orthographic or perspective).

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRealDirection()

Vector3 Ogre::Camera::getRealDirection | ( | void |  | ) | const

Gets the real world direction vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealOrientation()

const Quaternion& Ogre::Camera::getRealOrientation | ( | void |  | ) | const

Gets the real world orientation of the camera, including any rotation inherited from a node attachment.

## ◆ getRealPosition()

const Vector3& Ogre::Camera::getRealPosition | ( | void |  | ) | const

Gets the real world position of the camera, including any translation inherited from a node attachment.

## ◆ getRealRight()

Vector3 Ogre::Camera::getRealRight | ( | void |  | ) | const

Gets the real world right vector of the camera, including any rotation inherited from a node attachment.

## ◆ getRealUp()

Vector3 Ogre::Camera::getRealUp | ( | void |  | ) | const

Gets the real world up vector of the camera, including any rotation inherited from a node attachment.

## ◆ getReflectionMatrix()

virtual const Matrix4& Ogre::Frustum::getReflectionMatrix | ( | void |  | ) | const
| inlinevirtualinherited

Returns the reflection matrix of the frustum if appropriate.

## ◆ getReflectionPlane()

virtual const Plane& Ogre::Frustum::getReflectionPlane | ( | void |  | ) | const
| inlinevirtualinherited

Returns the reflection plane of the frustum if appropriate.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderOperation()

void Ogre::Frustum::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass
| ) |  |
| virtualinherited

Overridden from Renderable.

Implements Ogre::Renderable.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( | void |  | ) | const
| inlineinherited

## ◆ getRight()

Vector3 Ogre::Camera::getRight | ( | void |  | ) | const

Gets the camera's right vector.

## ◆ getSceneManager()

SceneManager* Ogre::Camera::getSceneManager | ( | void |  | ) | const

Returns a pointer to the SceneManager this camera is rendering through.

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getSquaredViewDepth()

Real Ogre::Frustum::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| inherited

Overridden from Renderable.

## ◆ getUp()

Vector3 Ogre::Camera::getUp | ( | void |  | ) | const

Gets the camera's up vector.

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::Renderable::getUseIdentityWorldMatrix | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the world matrix is an identity matrix.

Remarks
  It is up to the Hlms implementation whether to honour this request. Take in mind changes of this value at runtime may not be seen until the datablock is flushed. It is implemented as a virtual call because this functionality isn't required very often (hence we save per-Renderable space for those that don't use it) and this function will be called at creation time to use a different shader; not during rendering time per Renderable.

Reimplemented in Ogre::v1::BillboardSet.

## ◆ getUseMinPixelSize()

bool Ogre::Camera::getUseMinPixelSize | ( |  | ) | const
| inline

Returns whether to use min display size calculations.

See also
  Camera::setUseMinDisplaySize

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUseRenderingDistance()

virtual bool Ogre::Camera::getUseRenderingDistance | ( | void |  | ) | const
| inlinevirtual

Get whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

## ◆ getUserObjectBindings() [1/4]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/4]

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [3/4]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [4/4]

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray& Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inlineinherited

## ◆ getViewMatrix() [1/2]

const Matrix4& Ogre::Camera::getViewMatrix | ( | bool | ownFrustumOnly | ) | const

Specialised version of getViewMatrix allowing caller to differentiate whether the custom culling frustum should be allowed or not.

Remarks
  The default behaviour of the standard getViewMatrix is to delegate to the alternate culling frustum, if it is set. This is expected when performing CPU calculations, but the final rendering must be performed using the real view matrix in order to display the correct debug view.

## ◆ getViewMatrix() [2/2]

const Matrix4& Ogre::Camera::getViewMatrix | ( | void |  | ) | const
| virtual

Gets the view matrix for this frustum.

Mainly for use by OGRE internally.

Reimplemented from Ogre::Frustum.

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getVrData()

const VrData* Ogre::Camera::getVrData | ( | void |  | ) | const
| inline

## ◆ getVrProjectionMatrix()

Matrix4 Ogre::Camera::getVrProjectionMatrix | ( | size_t | eyeIdx | ) | const

## ◆ getVrViewMatrix()

Matrix4 Ogre::Camera::getVrViewMatrix | ( | size_t | eyeIdx | ) | const

## ◆ getWindowPlanes()

const PlaneList& Ogre::Camera::getWindowPlanes | ( | void |  | ) | const

Gets the window clip planes, only applicable if isWindowSet == true.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldSpaceCorners()

const Vector3* Ogre::Camera::getWorldSpaceCorners | ( | void |  | ) | const
| virtual

Gets the world space corners of the frustum.

Remarks
  The corners are ordered as follows: top-right near, top-left near, bottom-left near, bottom-right near, top-right far, top-left far, bottom-left far, bottom-right far.

Reimplemented from Ogre::Frustum.

## ◆ getWorldTransforms()

void Ogre::Camera::getWorldTransforms | ( | Matrix4 * | mat | ) | const
| virtual

Overridden from Frustum/Renderable.

Implements Ogre::Renderable.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( | void |  | ) | const
| inlineinherited

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isCustomNearClipPlaneEnabled()

virtual bool Ogre::Frustum::isCustomNearClipPlaneEnabled | ( | void |  | ) | const
| inlinevirtualinherited

Is a custom near clip plane in use?

## ◆ isCustomProjectionMatrixEnabled()

virtual bool Ogre::Frustum::isCustomProjectionMatrixEnabled | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether a custom projection matrix is in use.

## ◆ isCustomViewMatrixEnabled()

virtual bool Ogre::Frustum::isCustomViewMatrixEnabled | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether a custom view matrix is in use.

## ◆ isReflected()

virtual bool Ogre::Frustum::isReflected | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this frustum is being reflected.

## ◆ isRenderedRq()

bool Ogre::Camera::isRenderedRq | ( | size_t | rqId | ) | const
| inline

Returns true if the asked render queue has been rendered. False otherwise.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible() [1/4]

bool Ogre::Camera::isVisible | ( | const AxisAlignedBox & | bound,
|  | FrustumPlane * | culledBy = `0`
| ) |  | const
| virtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding box to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the box was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [2/4]

bool Ogre::Camera::isVisible | ( | const Sphere & | bound,
|  | FrustumPlane * | culledBy = `0`
| ) |  | const
| virtual

Tests whether the given container is visible in the Frustum.

Parameters

  bound | Bounding sphere to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [3/4]

bool Ogre::Camera::isVisible | ( | const Vector3 & | vert,
|  | FrustumPlane * | culledBy = `0`
| ) |  | const
| virtual

Tests whether the given vertex is visible in the Frustum.

Parameters

  vert | Vertex to be checked (world space).
  culledBy | Optional pointer to an int which will be filled by the plane number which culled the box if the result was `false`;

Returns
  If the sphere was visible, `true` is returned.

  Otherwise, `false` is returned.

Reimplemented from Ogre::Frustum.

## ◆ isVisible() [4/4]

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ isWindowSet()

virtual bool Ogre::Camera::isWindowSet | ( | void |  | ) | const
| inlinevirtual

Returns if a viewport window is being used.

## ◆ lookAt() [1/2]

void Ogre::Camera::lookAt | ( | const Vector3 & | targetPoint | ) |

Points the camera at a location in worldspace.

Remarks
  This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point.

Parameters

  targetPoint | A vector specifying the look at point.

## ◆ lookAt() [2/2]

void Ogre::Camera::lookAt | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Points the camera at a location in worldspace.

Remarks
  This is a helper method to automatically generate the direction vector for the camera, based on it's current position and the supplied look-at point.

Parameters

  x | The `x` co-ordinates of the point to look at.
  y | The `y` co-ordinates of the point to look at.
  z | The `z` co-ordinates of the point to look at.

## ◆ move()

void Ogre::Camera::move | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along world axes.

## ◆ moveRelative()

void Ogre::Camera::moveRelative | ( | const Vector3 & | vec | ) |

Moves the camera's position by the vector offset provided along it's own axes (relative to orientation).

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ pitch()

void Ogre::Camera::pitch | ( | const Radian & | angle | ) |

Pitches the camera up/down anticlockwise around it's local z axis.

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ projectSphere()

bool Ogre::Camera::projectSphere | ( | const Sphere & | sphere,
|  | Real * | left,
|  | Real * | top,
|  | Real * | right,
|  | Real * | bottom
| ) |  | const
| virtual

Project a sphere onto the near plane and get the bounding rectangle.

Parameters

  sphere | The world-space sphere to project.
  left | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  top | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  right | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).
  bottom | Pointers to destination values, these will be completed with the normalised device coordinates (in the range {-1,1}).

Returns
  `true` if the sphere was projected to a subset of the near plane, `false` if the entire near plane was contained.

Reimplemented from Ogre::Frustum.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inlineinherited

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ removeListener()

virtual void Ogre::Camera::removeListener | ( | Listener * | l | ) |
| virtual

Remove a listener to this camera.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ resetFrustumExtents()

virtual void Ogre::Frustum::resetFrustumExtents | ( |  | ) |
| virtualinherited

Reset the frustum extents to be automatically derived from other params.

## ◆ resetWindow()

virtual void Ogre::Camera::resetWindow | ( | void |  | ) |
| virtual

Cancel view window.

## ◆ roll()

void Ogre::Camera::roll | ( | const Radian & | angle | ) |

Rolls the camera anticlockwise, around its local z axis.

## ◆ rotate() [1/2]

void Ogre::Camera::rotate | ( | const Quaternion & | q | ) |

Rotate the camera around an arbitrary axis using a Quaternion.

## ◆ rotate() [2/2]

void Ogre::Camera::rotate | ( | const Vector3 & | axis,
|  | const Radian & | angle
| ) |  |

Rotate the camera around an arbitrary axis.

## ◆ setAspectRatio()

virtual void Ogre::Frustum::setAspectRatio | ( | Real | ratio | ) |
| virtualinherited

Sets the aspect ratio for the frustum viewport.

Remarks
  The ratio between the x and y dimensions of the rectangular area visible through the frustum is known as aspect ratio: aspect = width / height .

  The default for most fullscreen windows is 1.3333 - this is also assumed by Ogre unless you use this method to state otherwise.

## ◆ setAutoAspectRatio()

void Ogre::Camera::setAutoAspectRatio | ( | bool | autoratio | ) |

If set to true a viewport that owns this frustum will be able to recalculate the aspect ratio whenever the frustum is resized.

Remarks
  You should set this to true only if the frustum / camera is used by one viewport at the same time. Otherwise the aspect ratio for other viewports may be wrong.

## ◆ setAutoTracking()

void Ogre::Camera::setAutoTracking | ( | bool | enabled,
|  | SceneNode *const | target = `0`,
|  | const Vector3 & | offset = `Vector3::ZERO`
| ) |  |

Enables / disables automatic tracking of a SceneNode.

Remarks
  If you enable auto-tracking, this Camera will automatically rotate to look at the target SceneNode every frame, no matter how it or SceneNode move. This is handy if you want a Camera to be focused on a single object or group of objects. Note that by default the Camera looks at the origin of the SceneNode, if you want to tweak this, e.g. if the object which is attached to this target node is quite big and you want to point the camera at a specific point on it, provide a vector in the 'offset' parameter and the camera's target point will be adjusted.

Parameters

  enabled | If true, the Camera will track the SceneNode supplied as the next parameter (cannot be null). If false the camera will cease tracking and will remain in it's current orientation.
  target | Pointer to the SceneNode which this Camera will track. Make sure you don't delete this SceneNode before turning off tracking (e.g. SceneManager::clearScene will delete it so be careful of this). Can be null if and only if the enabled param is false.
  offset | If supplied, the camera targets this point in local space of the target node instead of the origin of the target node. Good for fine tuning the look at point.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setCullingFrustum()

void Ogre::Camera::setCullingFrustum | ( | Frustum * | frustum | ) |
| inline

Tells the camera to use a separate Frustum instance to perform culling.

Remarks
  By calling this method, you can tell the camera to perform culling against a different frustum to it's own. This is mostly useful for debug cameras that allow you to show the culling behaviour of another camera, or a manual frustum instance.

Parameters

  frustum | Pointer to a frustum to use; this can either be a manual Frustum instance (which you can attach to scene nodes like any other MovableObject), or another camera. If you pass 0 to this method it reverts the camera to normal behaviour.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) |  |
| inlineinherited

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setCustomProjectionMatrix()

virtual void Ogre::Frustum::setCustomProjectionMatrix | ( | bool | enable,
|  | const Matrix4 & | projectionMatrix = `Matrix4::IDENTITY`,
|  | bool | alternateDepthRange = `false`
| ) |  |
| virtualinherited

Set whether to use a custom projection matrix on this frustum.

Remarks
  This is an advanced method which allows you to manually set the projection matrix on this frustum, rather than having it calculate itself based on the clipping distances or the field of view.

See Frustum::setCustomViewMatrix

Note
  After enabling a custom projection matrix, the frustum will no longer update on its own based on field of view and near / far distance changes. You are completely responsible for keeping the projection matrix up to date if those values change. The custom matrix will be returned from getProjectionMatrix and derivative functions. Even when using a custom projection matrix, you should still call the methods that update the ner / far distances and field of view.

Parameters

  enable | If `true`, the custom projection matrix passed as the second parameter will be used in preference to an auto calculated one. If `false`, the frustum will revert to auto calculating the projection matrix.
  projectionMatrix | The custom view matrix to use.
  alternateDepthRange | Set this to true if the input projectionMatrix has the depth in range [0; 1] instead of the range [-1; 1] that Ogre expects.

Projection matrices obtained from Oculus SDK's need to set this to true.

Note that we will internally convert the projection matrix by performing the range conversion, so don't expect Frustum::getProjectionMatrix to return you exactly the same projection matrix you passed to us!

## ◆ setCustomViewMatrix()

virtual void Ogre::Frustum::setCustomViewMatrix | ( | bool | enable,
|  | const Matrix4 & | viewMatrix = `Matrix4::IDENTITY`
| ) |  |
| virtualinherited

Set whether to use a custom view matrix on this frustum.

Remarks
  This is an advanced method which allows you to manually set the view matrix on this frustum, rather than having it calculate itself based on it's position and orientation.

Note
  After enabling a custom view matrix, the frustum will no longer update on its own based on position / orientation changes. You are completely responsible for keeping the view matrix up to date. The custom matrix will be returned from getViewMatrix.

Parameters

  enable | If `true`, the custom view matrix passed as the second parameter will be used in preference to an auto calculated one. If false, the frustum will revert to auto calculating the view matrix.
  viewMatrix | The custom view matrix to use, the matrix must be an affine matrix.

See also
  Frustum::setCustomProjectionMatrix, Matrix4::isAffine

## ◆ setDatablock() [1/2]

virtual void Ogre::Renderable::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtualinherited

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |
| inherited

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName
| ) |  |
| inherited

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setDirection() [1/2]

void Ogre::Camera::setDirection | ( | const Vector3 & | vec | ) |

Sets the camera's direction vector.

## ◆ setDirection() [2/2]

void Ogre::Camera::setDirection | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Sets the camera's direction vector.

Remarks
  Note that the 'up' vector for the camera will automatically be recalculated based on the current 'up' vector (i.e. the roll will remain the same).

## ◆ setFarClipDistance()

virtual void Ogre::Frustum::setFarClipDistance | ( | Real | farDist | ) |
| virtualinherited

Sets the distance to the far clipping plane.

Remarks
  The view frustum is a pyramid created from the frustum position and the edges of the viewport. This method sets the distance for the far end of that pyramid. Different applications need different values: e.g. a flight sim needs a much further far clipping plane than a first-person shooter. An important point here is that the larger the ratio between near and far clipping planes, the lower the accuracy of the Z-buffer used to depth-cue pixels. This is because the Z-range is limited to the size of the Z buffer (16 or 32-bit) and the max values must be spread over the gap between near and far clip planes. As it happens, you can affect the accuracy far more by altering the near distance rather than the far distance, but keep this in mind.

Parameters

  farDist | The distance to the far clipping plane from the frustum in world coordinates.If you specify 0, this means an infinite view distance which is useful especially when projecting shadows; but be careful not to use a near distance too close.

## ◆ setFixedYawAxis()

void Ogre::Camera::setFixedYawAxis | ( | bool | useFixed,
|  | const Vector3 & | fixedAxis = `Vector3::UNIT_Y`
| ) |  |

Tells the camera whether to yaw around it's own local Y axis or a fixed axis of choice.

Remarks
  This method allows you to change the yaw behaviour of the camera
  - by default, the camera yaws around a fixed Y axis. This is often what you want - for example if you're making a first-person shooter, you really don't want the yaw axis to reflect the local camera Y, because this would mean a different yaw axis if the player is looking upwards rather than when they are looking straight ahead. You can change this behaviour by calling this method, which you will want to do if you are making a completely free camera like the kind used in a flight simulator.

Parameters

  useFixed | If `true`, the axis passed in the second parameter will always be the yaw axis no matter what the camera orientation. If false, the camera yaws around the local Y.
  fixedAxis | The axis to use if the first parameter is true.

## ◆ setFocalLength()

virtual void Ogre::Frustum::setFocalLength | ( | Real | focalLength = `1.0` | ) |
| virtualinherited

Sets frustum focal length (used in stereo rendering).

Parameters

  focalLength | The distance to the focal plane from the frustum in world coordinates.

## ◆ setFOVy()

virtual void Ogre::Frustum::setFOVy | ( | const Radian & | fovy | ) |
| virtualinherited

Sets the Y-dimension Field Of View (FOV) of the frustum.

Remarks
  Field Of View (FOV) is the angle made between the frustum's position, and the edges of the 'screen' onto which the scene is projected. High values (90+ degrees) result in a wide-angle, fish-eye kind of view, low values (30- degrees) in a stretched, telescopic kind of view. Typical values are between 45 and 60 degrees.

  This value represents the VERTICAL field-of-view. The horizontal field of view is calculated from this depending on the dimensions of the viewport (they will only be the same if the viewport is square).

Note
  Setting the FOV overrides the value supplied for frustum::setNearClipPlane.

## ◆ setFrustumExtents()

virtual void Ogre::Frustum::setFrustumExtents | ( | Real | left,
|  | Real | right,
|  | Real | top,
|  | Real | bottom,
|  | FrustrumExtentsType | frustrumExtentsType = `FET_PROJ_PLANE_POS`
| ) |  |
| virtualinherited

Manually set the extents of the frustum.

Parameters

  left,right,top,bottom | The position where the side clip planes intersect the near clip plane, in eye space OR the tangent of the half angles from the eye to the edges of the near clip plane
  frustrumExtentsType | Specifies how the extents are represented. Be default they are the positions on near clip plane. However if this is a scene camera it is recommended that you actually use the tangent of the half angles. ie Half the FoV angles. This is because Ogre uses this camera setup to calculate custom clipping planes for PSSM algorithms, and Forward+ algorithms, but alter the near and far clip distances.

  If you supply extents as positions on the projection plane the near clip distance has already been calculated as part of the supplied extents, however if they are tangent of the half angles Ogre can apply different near clip distances dynamically.

## ◆ setFrustumOffset() [1/2]

virtual void Ogre::Frustum::setFrustumOffset | ( | const Vector2 & | offset | ) |
| virtualinherited

Sets frustum offsets, used in stereo rendering.

Remarks
  You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets.

  The frustum offsets is in world coordinates, and default to (0, 0) - no offsets.

Parameters

  offset | The horizontal and vertical plane offsets.

## ◆ setFrustumOffset() [2/2]

virtual void Ogre::Frustum::setFrustumOffset | ( | Real | horizontal = `0.0`,
|  | Real | vertical = `0.0`
| ) |  |
| virtualinherited

Sets frustum offsets, used in stereo rendering.

Remarks
  You can set both horizontal and vertical plane offsets of "eye"; in stereo rendering frustum is moved in horizontal plane. To be able to render from two "eyes" you'll need two cameras rendering on two RenderTargets.

  The frustum offsets is in world coordinates, and default to (0, 0) - no offsets.

Parameters

  horizontal | The horizontal plane offset.
  vertical | The vertical plane offset.

## ◆ setLightCullingVisibility()

void Ogre::Camera::setLightCullingVisibility | ( | bool | collectLights,
|  | bool | isCubemap
| ) |  |

When a camera is created via SceneManager::createCamera, there are two additional parameters.

Parameters

  collectLights | Tell Ogre to cull lights against this camera. This requires additional CPU power. If a camera is not going to be used for a long time (or it doesn't need lights, which is what happens with shadow mapping cameras) you want this set to false. Otherwise if you need to render and need lights, enable this setting.
  isCubemap | Use an alternative algorithm to collect lights in 360° around the camera. This is required if the camera is going to be used in passes where CompositorPassSceneDef::mCameraCubemapReorient = true; Does nothing if collectLights = false

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setLodBias()

void Ogre::Camera::setLodBias | ( | Real | factor = `1.0` | ) |

Sets the level-of-detail factor for this Camera.

Remarks
  This method can be used to influence the overall level of detail of the scenes rendered using this camera. Various elements of the scene have level-of-detail reductions to improve rendering speed at distance; this method allows you to hint to those elements that you would like to adjust the level of detail that they would normally use (up or down).

  The most common use for this method is to reduce the overall level of detail used for a secondary camera used for sub viewports like rear-view mirrors etc. Note that scene elements are at liberty to ignore this setting if they choose, this is merely a hint.

Parameters

  factor | The factor to apply to the usual level of detail calculation. Higher values increase the detail, so 2.0 doubles the normal detail and 0.5 halves it.

## ◆ setLodCamera()

virtual void Ogre::Camera::setLodCamera | ( | const Camera * | lodCam | ) |
| virtual

Set a pointer to the camera which should be used to determine LOD settings.

Remarks
  Sometimes you don't want the LOD of a render to be based on the camera that's doing the rendering, you want it to be based on a different camera. A good example is when rendering shadow maps, since they will be viewed from the perspective of another camera. Therefore this method lets you associate a different camera instance to use to determine the LOD.

  To revert the camera to determining LOD based on itself, call this method with a pointer to itself.

## ◆ setMaterial()

virtual void Ogre::Renderable::setMaterial | ( | const MaterialPtr & | material | ) |
| virtualinherited

Sets the given material. Overrides HLMS materials.

Reimplemented in Ogre::v1::SubEntity, Ogre::v1::BillboardSet, and Ogre::v1::SimpleRenderable.

## ◆ setMaterialName()

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName
| ) |  |
| inherited

Sets the name of the Material to be used. Prefer using HLMS @See setHlms.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setNearClipDistance()

virtual void Ogre::Frustum::setNearClipDistance | ( | Real | nearDist | ) |
| virtualinherited

Sets the position of the near clipping plane.

Remarks
  The position of the near clipping plane is the distance from the frustums position to the screen on which the world is projected. The near plane distance, combined with the field-of-view and the aspect ratio, determines the size of the viewport through which the world is viewed (in world co-ordinates). Note that this world viewport is different to a screen viewport, which has it's dimensions expressed in pixels. The frustums viewport should have the same aspect ratio as the screen viewport it renders into to avoid distortion.

Parameters

  nearDist | The distance to the near clipping plane from the frustum in world coordinates.

## ◆ setOrientation()

void Ogre::Camera::setOrientation | ( | const Quaternion & | q | ) |

Sets the camera's orientation.

## ◆ setOrientationMode()

void Ogre::Frustum::setOrientationMode | ( | OrientationMode | orientationMode | ) |
| inherited

Set the orientation mode of the frustum.

Default is OR_DEGREE_0

Remarks
  Setting the orientation of a frustum is only supported on iOS at this time. An exception is thrown on other platforms.

## ◆ setOrthoWindow()

virtual void Ogre::Frustum::setOrthoWindow | ( | Real | w,
|  | Real | h
| ) |  |
| virtualinherited

Sets the orthographic window settings, for use with orthographic rendering only.

Note
  Calling this method will recalculate the aspect ratio, use setOrthoWindowHeight or setOrthoWindowWidth alone if you wish to preserve the aspect ratio but just fit one or other dimension to a particular size.

Parameters

  w | The width of the view window in world units.
  h | The height of the view window in world units.

## ◆ setOrthoWindowHeight()

virtual void Ogre::Frustum::setOrthoWindowHeight | ( | Real | h | ) |
| virtualinherited

Sets the orthographic window height, for use with orthographic rendering only.

Note
  The width of the window will be calculated from the aspect ratio.

Parameters

  h | The height of the view window in world units.

## ◆ setOrthoWindowWidth()

virtual void Ogre::Frustum::setOrthoWindowWidth | ( | Real | w | ) |
| virtualinherited

Sets the orthographic window width, for use with orthographic rendering only.

Note
  The height of the window will be calculated from the aspect ratio.

Parameters

  w | The width of the view window in world units.

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtualinherited

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoseWeight()

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ setPosition() [1/2]

void Ogre::Camera::setPosition | ( | const Vector3 & | vec | ) |

Sets the camera's position.

## ◆ setPosition() [2/2]

void Ogre::Camera::setPosition | ( | Real | x,
|  | Real | y,
|  | Real | z
| ) |  |

Sets the camera's position.

## ◆ setProjectionType()

virtual void Ogre::Frustum::setProjectionType | ( | ProjectionType | pt | ) |
| virtualinherited

Sets the type of projection to use (orthographic or perspective).

Default is perspective.

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtualinherited

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented in Ogre::ParticleSystem, Ogre::Light, Ogre::InternalCubemapProbe, Ogre::v1::Entity, and Ogre::Decal.

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlineinherited

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inlineinherited

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inlineinherited

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUseMinPixelSize()

void Ogre::Camera::setUseMinPixelSize | ( | bool | enable | ) |
| inline

Sets whether to use min display size calculations.

When active, objects that derive from MovableObject whose size on the screen is less then a MovableObject::mMinPixelSize will not be rendered.

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

## ◆ setUseRenderingDistance()

virtual void Ogre::Camera::setUseRenderingDistance | ( | bool | use | ) |
| inlinevirtual

Set whether this camera should use the 'rendering distance' on objects to exclude distant objects from the final image.

The default behaviour is to use it.

Parameters

  use | True to use the rendering distance, false not to.

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ setVrData()

void Ogre::Camera::setVrData | ( | VrData * | vrData | ) |

Sets VR data for calculating left & right eyes See OpenVR sample for more info.

Parameters

  vrData | Pointer to valid VrData This pointer must remain valid while the Camera is using it. We won't free this pointer. It is the developer's responsability to free it once no longer in use. Multiple cameras can share the same VrData pointer. The internal data hold by VrData can be changed withohut having to call setVrData again

## ◆ setWindow()

virtual void Ogre::Camera::setWindow | ( | Real | left,
|  | Real | top,
|  | Real | right,
|  | Real | bottom
| ) |  |
| virtual

Sets the viewing window inside of viewport.

Remarks
  This method can be used to set a subset of the viewport as the rendering target.

Parameters

  left | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 0).
  top | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 0).
  right | Relative to Viewport - 0 corresponds to left edge, 1 - to right edge (default - 1).
  bottom | Relative to Viewport - 0 corresponds to top edge, 1 - to bottom edge (default - 1).

## ◆ synchroniseBaseSettingsWith()

virtual void Ogre::Camera::synchroniseBaseSettingsWith | ( | const Camera * | cam | ) |
| virtual

Synchronise core camera settings with another.

Remarks
  Copies the position, orientation, clip distances, projection type, FOV, focal length and aspect ratio from another camera. Other settings like query flags, reflection etc are preserved.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## ◆ yaw()

void Ogre::Camera::yaw | ( | const Radian & | angle | ) |

Rotates the camera anticlockwise around it's local y axis.

## Friends And Related Function Documentation

## ◆ operator<<

_OgreExport friend std::ostream& operator<< | ( | std::ostream & | o,
|  | const Camera & | c
| ) |  |
| friend

Function for outputting to a stream.

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ INFINITE_FAR_PLANE_ADJUST

const Real Ogre::Frustum::INFINITE_FAR_PLANE_ADJUST
| staticinherited

Small constant used to reduce far plane projection to avoid inaccuracies.

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter
| inherited

Only valid when using low level materials.

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex
| inherited

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreCamera.h